diff --git a/docs/TODO.txt b/docs/TODO.txt
index b48ead17..2a2b3f56 100644
--- a/docs/TODO.txt
+++ b/docs/TODO.txt
@@ -13,17 +13,10 @@
 - change or add => to_string() to value.as_string
   and add as_repr, as_bool.
 
-- Make bool and num are incompatible
+- Make bool and num are incompatible (also it increase performance a bit).
   1 + true - make it not allowed.
 
 - support new line just after '=' (and other places)
-
-- REPL error message should be the first one (not the last).
-  >>> def f()
-  ...   _f = func()
-  ...     _f() // _f not defined (no closure).
-  ...   end
-  Error: Expected an expression // expected Name '_f' not defined.
   
 - literal function recursive call.
   func(a, b)
@@ -67,6 +60,16 @@
 - Complete the docs.
 - More Tests.
 
+// Enhancements
+
+- Write a custom hex() function to cast uint64_t to hex
+  string (currently our max is uint32_t) and for binary
+  (C doesn't have a sprintf("%b", num) for us.
+
+- Ensure that the bitwise optration result `a << b` can be fit
+  into a double value before casting it to one. and we're allowing
+  the integer overflow when shifting.
+
 // Bugs.
 It's at pre-alpha and every thing is left to
 implement, and nothing would be work as expected.
@@ -74,3 +77,10 @@ implement, and nothing would be work as expected.
 - f = func print() end; print(f) # semicollon should be there.
   def f() print() end print(f)   # semicollon should be there.
   make it okey to use semicollon freely like new lines.
+
+- REPL error message should be the first one (not the last).
+  >>> def f()
+  ...   _f = func()
+  ...     _f() // _f not defined (no closure).
+  ...   end
+  Error: Expected an expression // expected Name '_f' not defined.
\ No newline at end of file
diff --git a/src/pk_core.c b/src/pk_core.c
index d934c6d7..ff003d88 100644
--- a/src/pk_core.c
+++ b/src/pk_core.c
@@ -1020,15 +1020,17 @@ void initializeCore(PKVM* vm) {
 /* OPERATORS                                                                 */
 /*****************************************************************************/
 
-#define UNSUPPORT_OPERAND_TYPES(op)                                    \
+#define UNSUPPORTED_OPERAND_TYPES(op)                                  \
   VM_SET_ERROR(vm, stringFormat(vm, "Unsupported operand types for "   \
     "operator '" op "' $ and $", varTypeName(v1), varTypeName(v2)))
 
-Var varAdd(PKVM* vm, Var v1, Var v2) {
+#define RIGHT_OPERAND "Right operand"
 
+Var varAdd(PKVM* vm, Var v1, Var v2) {
   double d1, d2;
+
   if (isNumeric(v1, &d1)) {
-    if (validateNumeric(vm, v2, &d2, "Right operand")) {
+    if (validateNumeric(vm, v2, &d2, RIGHT_OPERAND)) {
       return VAR_NUM(d1 + d2);
     }
     return VAR_NULL;
@@ -1063,55 +1065,57 @@ Var varAdd(PKVM* vm, Var v1, Var v2) {
     }
   }
 
-  UNSUPPORT_OPERAND_TYPES("+");
+  UNSUPPORTED_OPERAND_TYPES("+");
   return VAR_NULL;
 }
 
 Var varSubtract(PKVM* vm, Var v1, Var v2) {
   double d1, d2;
+
   if (isNumeric(v1, &d1)) {
-    if (validateNumeric(vm, v2, &d2, "Right operand")) {
+    if (validateNumeric(vm, v2, &d2, RIGHT_OPERAND)) {
       return VAR_NUM(d1 - d2);
     }
     return VAR_NULL;
   }
 
-  UNSUPPORT_OPERAND_TYPES("-");
+  UNSUPPORTED_OPERAND_TYPES("-");
   return VAR_NULL;
 }
 
 Var varMultiply(PKVM* vm, Var v1, Var v2) {
-
   double d1, d2;
+
   if (isNumeric(v1, &d1)) {
-    if (validateNumeric(vm, v2, &d2, "Right operand")) {
+    if (validateNumeric(vm, v2, &d2, RIGHT_OPERAND)) {
       return VAR_NUM(d1 * d2);
     }
     return VAR_NULL;
   }
 
-  UNSUPPORT_OPERAND_TYPES("*");
+  UNSUPPORTED_OPERAND_TYPES("*");
   return VAR_NULL;
 }
 
 Var varDivide(PKVM* vm, Var v1, Var v2) {
   double d1, d2;
+
   if (isNumeric(v1, &d1)) {
-    if (validateNumeric(vm, v2, &d2, "Right operand")) {
+    if (validateNumeric(vm, v2, &d2, RIGHT_OPERAND)) {
       return VAR_NUM(d1 / d2);
     }
     return VAR_NULL;
   }
 
-  UNSUPPORT_OPERAND_TYPES("/");
+  UNSUPPORTED_OPERAND_TYPES("/");
   return VAR_NULL;
 }
 
 Var varModulo(PKVM* vm, Var v1, Var v2) {
-
   double d1, d2;
+
   if (isNumeric(v1, &d1)) {
-    if (validateNumeric(vm, v2, &d2, "Right operand")) {
+    if (validateNumeric(vm, v2, &d2, RIGHT_OPERAND)) {
       return VAR_NUM(fmod(d1, d2));
     }
     return VAR_NULL;
@@ -1122,40 +1126,83 @@ Var varModulo(PKVM* vm, Var v1, Var v2) {
     TODO; // "fmt" % v2.
   }
 
-  UNSUPPORT_OPERAND_TYPES("%");
+  UNSUPPORTED_OPERAND_TYPES("%");
   return VAR_NULL;
 }
 
 Var varBitAnd(PKVM* vm, Var v1, Var v2) {
-
   int64_t i1, i2;
+
   if (isInteger(v1, &i1)) {
-    if (validateInteger(vm, v2, &i2, "Right operand")) {
+    if (validateInteger(vm, v2, &i2, RIGHT_OPERAND)) {
       return VAR_NUM((double)(i1 & i2));
     }
     return VAR_NULL;
   }
 
-  UNSUPPORT_OPERAND_TYPES("&");
+  UNSUPPORTED_OPERAND_TYPES("&");
   return VAR_NULL;
 }
 
 Var varBitOr(PKVM* vm, Var v1, Var v2) {
-
   int64_t i1, i2;
+
   if (isInteger(v1, &i1)) {
-    if (validateInteger(vm, v2, &i2, "Right operand")) {
+    if (validateInteger(vm, v2, &i2, RIGHT_OPERAND)) {
       return VAR_NUM((double)(i1 | i2));
     }
     return VAR_NULL;
   }
 
-  UNSUPPORT_OPERAND_TYPES("|");
+  UNSUPPORTED_OPERAND_TYPES("|");
+  return VAR_NULL;
+}
+
+Var varBitXor(PKVM* vm, Var v1, Var v2) {
+  int64_t i1, i2;
+
+  if (isInteger(v1, &i1)) {
+    if (validateInteger(vm, v2, &i2, RIGHT_OPERAND)) {
+      return VAR_NUM((double)(i1 ^ i2));
+    }
+    return VAR_NULL;
+  }
+
+  UNSUPPORTED_OPERAND_TYPES("^");
+  return VAR_NULL;
+}
+
+Var varBitLshift(PKVM* vm, Var v1, Var v2) {
+  int64_t i1, i2;
+
+  if (isInteger(v1, &i1)) {
+    if (validateInteger(vm, v2, &i2, RIGHT_OPERAND)) {
+      return VAR_NUM((double)(i1 << i2));
+    }
+    return VAR_NULL;
+  }
+
+  UNSUPPORTED_OPERAND_TYPES("<<");
+  return VAR_NULL;
+}
+
+Var varBitRshift(PKVM* vm, Var v1, Var v2) {
+  int64_t i1, i2;
+
+  if (isInteger(v1, &i1)) {
+    if (validateInteger(vm, v2, &i2, RIGHT_OPERAND)) {
+      return VAR_NUM((double)(i1 >> i2));
+    }
+    return VAR_NULL;
+  }
+
+  UNSUPPORTED_OPERAND_TYPES(">>");
   return VAR_NULL;
 }
 
 bool varGreater(Var v1, Var v2) {
   double d1, d2;
+
   if (isNumeric(v1, &d1) && isNumeric(v2, &d2)) {
     return d1 > d2;
   }
@@ -1166,6 +1213,7 @@ bool varGreater(Var v1, Var v2) {
 
 bool varLesser(Var v1, Var v2) {
   double d1, d2;
+
   if (isNumeric(v1, &d1) && isNumeric(v2, &d2)) {
     return d1 < d2;
   }
@@ -1174,6 +1222,9 @@ bool varLesser(Var v1, Var v2) {
   return false;
 }
 
+#undef RIGHT_OPERAND
+#undef UNSUPPORTED_OPERAND_TYPES
+
 // Here we're switching the FNV-1a hash value of the name (cstring). Which is
 // an efficient way than having multiple if (attrib == "name"). From O(n) * k
 // to O(1) where n is the length of the string and k is the number of string
diff --git a/src/pk_core.h b/src/pk_core.h
index f33b01f2..ff391ce8 100644
--- a/src/pk_core.h
+++ b/src/pk_core.h
@@ -30,14 +30,17 @@ Script* getCoreLib(const PKVM* vm, String* name);
 /* OPERATORS                                                                 */
 /*****************************************************************************/
 
-Var varAdd(PKVM* vm, Var v1, Var v2);      // Returns v1 + v2.
-Var varSubtract(PKVM* vm, Var v1, Var v2); // Returns v1 - v2.
-Var varMultiply(PKVM* vm, Var v1, Var v2); // Returns v1 * v2.
-Var varDivide(PKVM* vm, Var v1, Var v2);   // Returns v1 / v2.
-Var varModulo(PKVM* vm, Var v1, Var v2);   // Returns v1 % v2.
-
-Var varBitAnd(PKVM* vm, Var v1, Var v2);   // Returns v1 & v2.
-Var varBitOr(PKVM* vm, Var v1, Var v2);    // Returns v1 | v2.
+Var varAdd(PKVM* vm, Var v1, Var v2);         // Returns v1 + v2.
+Var varSubtract(PKVM* vm, Var v1, Var v2);    // Returns v1 - v2.
+Var varMultiply(PKVM* vm, Var v1, Var v2);    // Returns v1 * v2.
+Var varDivide(PKVM* vm, Var v1, Var v2);      // Returns v1 / v2.
+Var varModulo(PKVM* vm, Var v1, Var v2);      // Returns v1 % v2.
+
+Var varBitAnd(PKVM* vm, Var v1, Var v2);      // Returns v1 & v2.
+Var varBitOr(PKVM* vm, Var v1, Var v2);       // Returns v1 | v2.
+Var varBitXor(PKVM* vm, Var v1, Var v2);      // Returns v1 ^ v2.
+Var varBitLshift(PKVM* vm, Var v1, Var v2);   // Returns v1 << v2.
+Var varBitRshift(PKVM* vm, Var v1, Var v2);   // Returns v1 >> v2.
 
 bool varGreater(Var v1, Var v2); // Returns v1 > v2.
 bool varLesser(Var v1, Var v2);  // Returns v1 < v2.
diff --git a/src/pk_vm.c b/src/pk_vm.c
index 91d515a9..0ca4edc2 100644
--- a/src/pk_vm.c
+++ b/src/pk_vm.c
@@ -1256,9 +1256,43 @@ static PkResult runFiber(PKVM* vm, Fiber* fiber) {
     }
 
     OPCODE(BIT_XOR):
+    {
+      // Don't pop yet, we need the reference for gc.
+      Var r = PEEK(-1), l = PEEK(-2);
+
+      Var result = varBitXor(vm, l, r);
+      DROP(); DROP(); // r, l
+      PUSH(result);
+
+      CHECK_ERROR();
+      DISPATCH();
+    }
+
     OPCODE(BIT_LSHIFT):
+    {
+      // Don't pop yet, we need the reference for gc.
+      Var r = PEEK(-1), l = PEEK(-2);
+
+      Var result = varBitLshift(vm, l, r);
+      DROP(); DROP(); // r, l
+      PUSH(result);
+
+      CHECK_ERROR();
+      DISPATCH();
+    }
+
     OPCODE(BIT_RSHIFT):
-      TODO;
+    {
+      // Don't pop yet, we need the reference for gc.
+      Var r = PEEK(-1), l = PEEK(-2);
+
+      Var result = varBitRshift(vm, l, r);
+      DROP(); DROP(); // r, l
+      PUSH(result);
+
+      CHECK_ERROR();
+      DISPATCH();
+    }
 
     OPCODE(EQEQ):
     {
diff --git a/tests/lang/basics.pk b/tests/lang/basics.pk
index af948730..28a14ed7 100644
--- a/tests/lang/basics.pk
+++ b/tests/lang/basics.pk
@@ -45,6 +45,20 @@ assert((1 & 1) == 1)
 assert((1 & 2) == 0)
 assert((4 & 7) == 4)
 
+assert((1 ^ 1) == 0)
+assert((1 ^ 3) == 2)
+assert((2 ^ 9) == 11)
+assert((0 ^ 0) == 0)
+
+assert((1 << 0) == 1)
+assert((1 << 2) == 4)
+assert((3 << 2) == 12)
+
+assert((1 >> 0) == 0)
+assert((8 >> 1) == 4)
+assert((8 >> 2) == 2)
+assert((4 >> 2) == 1)
+
 # If we got here with no errors, then all test passed
 print('All tests PASSED (100%)')
 
